import numpy as np

np.random.seed(seed=1)


#for i in range(0,10):
#   print np.random.randint(0,high=2)



total_dollars = {}
for i in range(-64,64):
    total_dollars[i] = 0

max_simulations = 1000000

for simulation_num in range(0,max_simulations):
   current_dollars = 63
   
   bet_size = 1
   bet_num = 0
   while(bet_num < 64):  # make 64 strings of bets
       result = np.random.randint(0,high=2)  # make a bet
       
       if (result == 0):  # lost bet
           current_dollars = current_dollars - bet_size
           if (current_dollars >= bet_size*2):  # double the bet if we can
               bet_size = bet_size*2
           else:  # otherwise start at $1
               bet_size = 1 
               bet_num += 1  # onto the next string of bets
       else: # won bet
           current_dollars = current_dollars + bet_size
           bet_size = 1
           bet_num += 1   # onto the next string of bets
       
       #print result, bet_size, current_dollars
       
       if (current_dollars ==0):  # out of money
           break
   
   net_dollars = current_dollars - 63
   #print net_dollars
   
   
   if (net_dollars in total_dollars):
       total_dollars[net_dollars] = total_dollars[net_dollars]+1
   else:
       total_dollars[net_dollars] = 1
       
       

result_list = []
for net_dollars, count1 in total_dollars.items():
    result_list.append([net_dollars, count1])
    
result_list.sort()

output_file = open('gamblers_ruin_results.txt','wb')
for line1 in result_list:
    output_file.write(str(line1[0]) + '        ' + str(line1[1]/float(max_simulations)) + ' \n')